com.fasterxml.jackson.databind.deser.std

## Class FromStringDeserializer<T>

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
    - - com.fasterxml.jackson.databind.deser.std.StdScalarDeserializer<T>
      - - com.fasterxml.jackson.databind.deser.std.FromStringDeserializer<T>

- All Implemented Interfaces:
    NullValueProvider, Serializable
  Direct Known Subclasses:
    CoreXMLDeserializers.Std, DOMDeserializer, FromStringDeserializer.Std, UUIDDeserializer

      public abstract class FromStringDeserializer<T>
      extends StdScalarDeserializer<T>

  Base class for simple deserializers that serialize values from String representation: this includes JSON Strings and other Scalar values that can be coerced into text, like Numbers and Booleans). Simple JSON String values are trimmed using `String.trim()`. Partial deserializer implementation will try to first access current token as a String, calls `_deserialize(String,DeserializationContext)` and returns return value. If this does not work (current token not a simple scalar type), attempts are made so that:
  - Embedded values (`JsonToken.VALUE_EMBEDDED_OBJECT`) are returned as-is if they are of compatible type
  - Arrays may be "unwrapped" if (and only if) `DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS` is enabled, and array contains just a single scalar value that can be deserialized (for example, JSON Array with single JSON String element).

  Special handling includes:

  - Null values (`JsonToken.VALUE_NULL`) are handled by returning value returned by `JsonDeserializer.getNullValue(DeserializationContext)`: default implementation simply returns Java `null` but this may be overridden.
  - Empty String (after trimming) will result in `_deserializeFromEmptyString()` getting called, and return value being returned as deserialization: default implementation simply returns `null`.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `FromStringDeserializer.Std` "Chameleon" deserializer that works on simple types that are deserialized from a simple String.

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_valueClass, _valueType, F_MASK_ACCEPT_ARRAYS, F_MASK_INT_COERCIONS`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `FromStringDeserializer(Class<?> vc)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected abstract T` | `_deserialize(String value, DeserializationContext ctxt)`
    `protected T` | `_deserializeEmbedded(Object ob, DeserializationContext ctxt)`
    `protected T` | `_deserializeFromEmptyString()`
    `T` | `deserialize(JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `static FromStringDeserializer.Std` | `findDeserializer(Class<?> rawType)` Factory method for trying to find a deserializer for one of supported types that have simple from-String serialization.
    `static Class<?>[]` | `types()`

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdScalarDeserializer

      `deserialize, deserializeWithType, getEmptyAccessPattern, getNullAccessPattern, supportsUpdate`

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_byteOverflow, _coercedTypeDesc, _coerceEmptyString, _coerceIntegral, _coerceNullToken, _coerceTextualNull, _deserializeFromArray, _deserializeFromEmpty, _deserializeWrappedValue, _failDoubleToIntCoercion, _findNullProvider, _hasTextualNull, _intOverflow, _isEmptyOrTextualNull, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _neitherNull, _nonNullNumber, _parseBooleanFromInt, _parseBooleanPrimitive, _parseBytePrimitive, _parseDate, _parseDate, _parseDateFromArray, _parseDoublePrimitive, _parseDoublePrimitive, _parseFloatPrimitive, _parseFloatPrimitive, _parseIntPrimitive, _parseIntPrimitive, _parseLongPrimitive, _parseLongPrimitive, _parseShortPrimitive, _parseString, _reportFailedNullCoerce, _shortOverflow, _verifyEndArrayForSingle, _verifyNullForPrimitive, _verifyNullForPrimitiveCoercion, _verifyNullForScalarCoercion, _verifyNumberForScalarCoercion, _verifyStringForScalarCoercion, findContentNullProvider, findContentNullStyle, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, findValueNullProvider, getValueClass, getValueType, getValueType, handledType, handleMissingEndArrayForSingle, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `deserializeWithType, findBackReference, getDelegatee, getEmptyValue, getEmptyValue, getKnownPropertyNames, getNullValue, getNullValue, getObjectIdReader, isCachable, replaceDelegatee, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### FromStringDeserializer

          protected FromStringDeserializer(Class<?> vc)

  - ### Method Detail

    - #### types

          public static Class<?>[] types()

    - #### findDeserializer

          public static FromStringDeserializer.Std findDeserializer(Class<?> rawType)

      Factory method for trying to find a deserializer for one of supported types that have simple from-String serialization.

    - #### deserialize

          public T deserialize(JsonParser p,
                               DeserializationContext ctxt)
                        throws IOException

      Description copied from class: `JsonDeserializer`
      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

      The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

                {
                    "@class": "class name",
                    ...
                }

      Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

                 if (p.currentToken() == JsonToken.START_OBJECT) {
                   p.nextToken();
                 }

      This results in the stream pointing to the field name, so that the two conditions align.

      Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Specified by:
        `deserialize` in class `JsonDeserializer<T>`
      Parameters:
        `p` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserialized value
      Throws:
        `IOException`

    - #### _deserialize

          protected abstract T _deserialize(String value,
                                            DeserializationContext ctxt)
                                     throws IOException

      Throws:
        `IOException`

    - #### _deserializeEmbedded

          protected T _deserializeEmbedded(Object ob,
                                           DeserializationContext ctxt)
                                    throws IOException

      Throws:
        `IOException`

    - #### _deserializeFromEmptyString

          protected T _deserializeFromEmptyString()
                                           throws IOException

      Throws:
        `IOException`

Copyright © 2008–2020 FasterXML. All rights reserved.